#include <fstream>
#include <algorithm>
using namespace std;

ifstream fin("cb3.in");
ofstream fout("cb3.out");
    
int n;
int sp[10001], x[10001];

int Cb(int sum)
{
    int st = 1, dr = n, m;
    int poz = 0;
    
    while (st <= dr)
    {
        m = (st + dr) / 2;
        if ( sp[m] <= sum )
        {
            poz = m;
            st = m + 1;
        }
        else 
			dr = m - 1;
    }
    return poz;
}

int main()
{
	int q, sum;
    fin >> n >> q;
    for ( int i = 1; i <= n; i++)
        fin >> x[i];
        
    sort(x + 1, x + n + 1);
    
    for (int i = 1; i <= n; ++i)
        sp[i] = sp[i - 1] + x[i];
    
    while (q--)
    {
        fin >> sum;
        fout << Cb(sum) << '\n';
    }
    
    fin.close();
    fout.close();
    
    return 0;
}
