#include <fstream>
#include <iostream>
#include <algorithm>

using namespace std;

ifstream fin("0-pow2.in");
ofstream fout("pow2.out");

long long p2[32];  
int a[100005], n;
int b[100005], m;
int L[100005];

int Cb(int st, int dr, int i);

void Write(int a[], int n)
{
	for (int i = 1; i <= n; ++i)
		fout << a[i] << ' ';
	fout << '\n';
	
}

int main()
{
	fin >> n;
	for (int i = 1; i <= n; i++) 
		fin >> a[i];   
	
	
	p2[0] = 1;                              
	for (int i = 1; i <= 31; ++i) 
		p2[i] = p2[i - 1] * 2;
		
   int cnt = 0, x;
    
   for (int k = 0; k <= 30; ++k)            
	   for (int i = 1; i < n; ++i)              
			for (int j = i + 1; j <= n; ++j)
			{
				if (a[i] + a[j] == p2[k])
					cnt++;
      }

   fout << cnt << '\n';
   return 0;
}

int Cb(int st, int dr, int x)
{
	int mj;
	while (st <= dr)
	{
		mj = (st + dr) >> 1;    
        if (x == b[mj])             
          return mj;                   
	
       	if (x < b[mj]) 
			dr = mj - 1;
        else 
			st = mj + 1;       
	}
  
	return -1;
}

